# NOTE: Derived from blib/lib/Apache/Traffic.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Apache::Traffic;

#line 180 "blib/lib/Apache/Traffic.pm (autosplit into blib/lib/auto/Apache/Traffic/remove.al)"
sub remove {
  my($start, $end) = @_;
  my(%db, $db_obj);

  $start = timegm(0, 0, 0, (localtime($start))[3..5]); # START OF DAY
  $end   = timegm(0, 0, 0, (localtime($end))[3..5]);
  tie(%STATS, 'IPC::Shareable', SHMKEY, { create => 'no' })
    or return error("unable to tie to shared memory");
  if (-e DBPATH) {
    $db_obj = tie %db, 'DB_File', DBPATH, O_RDWR, MODE
      or return error("unable to tie dbm file: $!");
  }
  (defined($SEMID = semget(SEMKEY, 1, MODE))) 
    or return error("unable to obtain semaphore for locking: $!");
  semop($SEMID, pack "s*", 0, 0, 0, 0, 1, SEM_UNDO)
    or return error("unable to obtain lock: $!");
  while($start <= $end) {
    delete $STATS{$start};
    delete $db{$start} if (defined $db_obj);
    $start += ONEDAY;
  }
  $db_obj->sync if (defined $db_obj);
  semop($SEMID, pack "s*", 0, -1, SEM_UNDO)
    or return error("unable to release lock: $!");
  1;
}

# end of Apache::Traffic::remove
1;
